unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics,
  Controls, Forms, Dialogs, RVFile, RichViewXML, RVUniscribeGrIn,
  RVStyle, RVScroll, RichView, RVTypes;

type
  TForm1 = class(TForm)
    RichView1: TRichView;
    RichViewXML1: TRichViewXML;
    RVStyle1: TRVStyle;
    procedure FormCreate(Sender: TObject);
    procedure RichView1SaveDocXExtra(Sender: TCustomRichView;
      Area: TRVDocXSaveArea; Obj: TObject; Index1, Index2: Integer;
      var OOXMLCode: TRVUnicodeString);
  private
    { Private declarations }
  public
    { Public declarations }
    LastParaItemNoArray: array of Integer;
    DocIndex, DocCount: Integer;
    procedure AddDoc(const FileName: String; DocIndex: Integer);
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

{ TForm1 }

procedure TForm1.AddDoc(const FileName: String; DocIndex: Integer);
var
  ItemCount, LastParaItemNo: Integer;
begin
  ItemCount := RichView1.ItemCount;
  RichViewXML1.AppendFromFile(FileName);
  Assert(RichView1.ItemCount > ItemCount);
  LastParaItemNo := RichView1.ItemCount - 1;
  while not RichView1.IsParaStart(LastParaItemNo) do
    dec(LastParaItemNo);
  LastParaItemNoArray[DocIndex] := LastParaItemNo;
end;

procedure TForm1.FormCreate(Sender: TObject);
var
  i: Integer;
begin
  RichView1.Clear;
  DocCount := 5;
  SetLength(LastParaItemNoArray, DocCount);

  for i := 1 to DocCount do
    AddDoc(ExtractFilePath(Application.ExeName) + IntToStr(i) + '.xml', i - 1);
  RichView1.Format;
  DocIndex := 0;
  RichView1.SaveDocX(ExtractFilePath(Application.ExeName) + 'test.docx', False);
end;

procedure TForm1.RichView1SaveDocXExtra(Sender: TCustomRichView;
  Area: TRVDocXSaveArea; Obj: TObject; Index1, Index2: Integer;
  var OOXMLCode: TRVUnicodeString);
begin
  if (Area = rv_docxs_ParaStyle) and
  (DocIndex < DocCount-1) and (Index2 = LastParaItemNoArray[DocIndex]) then
  begin
    OOXMLCode := '<w:sectPr><w:type w:val="continuous"/></w:sectPr>';
    inc(DocIndex);
  end;
end;

end.
